//+------------------------------------------------------------------+
//|                                                       .mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

#include <Trade\SymbolInfo.mqh>
#include <Indicators\Trend.mqh>
#include <Trade\Trade.mqh>
#include <Trade\AccountInfo.mqh>


//--- input parameters
input string   Simbol="EURUSD";

input int      EMA_1=4;
input int      EMA_2=6;
input int      EMA_3=15;
input int      EMA_4=15;
input int      EMA_5=10;
input double   PSAR_shag=0.02;
input double   PSAR_max=0.2;
input int      Tenkan=9;
input int      Kijun=26;
input int      Senkou=52;

input int      Sl=100;
input int      Tp=100;
input double   MaxLot=1.0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

int EMA_Arr[]={0,0,0,0,0};

CiMA CEMA_1;
CiMA CEMA_2;
CiMA CEMA_3;
CiMA CEMA_4;
CiMA CEMA_5;

CTrade trade;
CAccountInfo account;
CSymbolInfo mysymbol;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   int =0;
   mysymbol.Name(Simbol);

   EMA_Arr[0]=EMA_1;
   EMA_Arr[1]=EMA_1+EMA_2;
   EMA_Arr[2]=EMA_1+EMA_2+EMA_3;
   EMA_Arr[3]=EMA_1+EMA_2+EMA_3+EMA_4;
   EMA_Arr[4]=EMA_1+EMA_2+EMA_3+EMA_4+EMA_5;
   CEMA_1.Create(Simbol,PERIOD_CURRENT,EMA_Arr[++],0,MODE_EMA,PRICE_CLOSE);
   CEMA_2.Create(Simbol,PERIOD_CURRENT,EMA_Arr[++],0,MODE_EMA,PRICE_CLOSE);
   CEMA_3.Create(Simbol,PERIOD_CURRENT,EMA_Arr[++],0,MODE_EMA,PRICE_CLOSE);
   CEMA_4.Create(Simbol,PERIOD_CURRENT,EMA_Arr[++],0,MODE_EMA,PRICE_CLOSE);
   CEMA_5.Create(Simbol,PERIOD_CURRENT,EMA_Arr[++],0,MODE_EMA,PRICE_CLOSE);


//---           (NULL,PERIOD_CURRENT,EMA_1,0,MODE_EMA,PRICE_CLOSE)
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
int () //   
  {
//--- 0- ; -1 -; 1  
   int  ret=0;
   int =0; // -1  ,   +1    
   double  ima1=0.0;
   double  ima2=0.0;
   double  ima3=0.0;
   double  ima4=0.0;
   double  ima5=0.0;
printf("ima1 ="+ima1);
printf("ima2 ="+ima2);
printf("ima3 ="+ima3);
printf("ima4 ="+ima4);
printf("ima5 ="+ima5);
printf("iMA  =" + iMA(_Symbol,0,PERIOD_CURRENT,EMA_Arr[0],MODE_EMA,PRICE_MEDIAN));
   ima5=CEMA_5.Main(1);

   ima4=CEMA_4.Main(1);
   if(ima5<ima4){=1; ret=1;}
   else {=-1; ret=-1; }
   ima3=CEMA_3.Main(1);
   if(ima4*>ima3*){ ret=0; return(ret);}
   ima2=CEMA_2.Main(1);
   if(ima3*>ima2*){ ret=0; return(ret);}
   ima1=CEMA_1.Main(1);
   if(ima2*>ima1*){ ret=0; return(ret);}

printf("ima1 ="+ima1);
printf("ima2 ="+ima2);
printf("ima3 ="+ima3);
printf("ima4 ="+ima4);
printf("ima5 ="+ima5);


   return(ret);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int (int ) //       
  {
   int t=;
   int ret=0;
//EMA_Arr[0]


Print("  " + CEMA_1.Main(1) +" = "+ CEMA_2.Main(1));
   if(
      (CEMA_1.Main(1)*t>CEMA_2.Main(1)*t)
      //&& (CEMA_1.Main(2)*t>CEMA_2.Main(2)*t)
      )
     {Print("da");ret=t;return(ret); }
   else {Print("net");ret=0;return(ret);}

   return(ret);
  }
//+------------------------------------------------------------------+
//|  ,              |
//+------------------------------------------------------------------+
bool checkTrading()
  {
   bool can_trade=false;
//  ,       ..
   if(account.TradeAllowed() && account.TradeExpert() && mysymbol.IsSynchronized())
     {
      can_trade=true;

     }
   return(can_trade);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double (double =100.0)
  {
   double lot=0.0;
   lot=int(MaxLot**10)/1000.0;
// MathRand

   if(lot<0.1) { lot=0; return(lot);}

   return(lot);

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int (int ,double =100.0) // 0-100
  {
   int ret=0;
   double  lot=0.0;
   double price;
   double stloss;
   double tprofit;

   if(checkTrading()==false)
     {
      //      return(ret);

     }
   mysymbol.RefreshRates();
   lot=();
//lot=1;
   if(lot==0) {return(0);}
   if(==1)
     {

      price= NormalizeDouble(mysymbol.Last(),_Digits);               //---   ask
      stloss  = NormalizeDouble(mysymbol.Ask() - Sl*_Point,_Digits); //--- Stop Loss
      tprofit = NormalizeDouble(mysymbol.Ask() + Tp*_Point,_Digits); //--- Take Profit
      Print("price = "+mysymbol.Last());
      trade.Buy(lot,mysymbol.Name(),price,stloss,tprofit," ");
     }

   if(==-1)
     {
      Print("price = "+mysymbol.Last());
      price=NormalizeDouble(mysymbol.Bid(),_Digits);               //---   ask
      stloss  = NormalizeDouble(mysymbol.Bid() + Sl*_Point,_Digits); //--- Stop Loss
      tprofit = NormalizeDouble(mysymbol.Bid() - Tp*_Point,_Digits); //--- Take Profit


      trade.Sell(lot,mysymbol.Name(),price,stloss,tprofit," ");
     }

   return(ret);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   int t=0;
   t=();
   Print(" ="+t);

   t=(t);
   Print(""+t);
   if(t!=0){(t,100.0);}
  }
//+------------------------------------------------------------------+
